
const express = require('express')
const { WebSocketServer } = require('ws')

let trackIndex = 0 ;
const tracks = [
    {artist: 'Rick Astley', title: 'Never Gonna Give You Up'},
    {artist: 'Smash Mouth', title: 'All-Star'},
    {artist: 'Sound of Silence', title: 'Hello darkness, my old friend'},
    {artist: 'Flight of the Conchords', title: 'Foux Da Fa Fa'}
] ;

let jsonObjectTemplateTimelineTopic = {
	topic: 'player/timeline',
        timestamp: 0
};

let jsonObjectTemplateInfoTopic = {
        topic: 'player/info',
        data: {
            metadata: {
                artist: 'Rick Astley',
                title: 'Never Gonna Give You Up'
            }
        }
};

const webserver = express()
 .use((req, res) =>
   res.sendFile('/index.html', { root: __dirname })
 )
 .listen(3000);


let socket = new WebSocketServer({ port: 8080 });

socket.on('connection', (ws) => {
 const intervalIdMeta = setInterval(() => {
   const track = tracks[trackIndex] ;
   jsonObjectTemplateInfoTopic.data.metadata.artist = track.artist ;
   jsonObjectTemplateInfoTopic.data.metadata.title = track.title ;
   ws.send(JSON.stringify(jsonObjectTemplateInfoTopic));
   trackIndex += 1 ;
   if(trackIndex >= tracks.length) trackIndex = 0 ;
 }, 10000);
 const intervalIdTimeline = setInterval(() => {
   jsonObjectTemplateTimelineTopic.timestamp += 1000 ;
   ws.send(JSON.stringify(jsonObjectTemplateTimelineTopic));
 }, 1000);
 ws.on('close', () => {
        console.log("disconnected");
 	clearInterval(intervalIdMeta);
        clearInterval(intervalIdTimeline);
 });
});
